open B8_types

exception Colornestingmerge
exception Colornestingmergedeep

let pr_DEBUG s = prerr_endline s


let rec append_aux acc l = 
  match l with
    [] -> acc
  | x::l' -> append_aux (x::acc) l'

let  append l1 l2 = 
  append_aux l2 (List.rev l1)


let rec color_nesting d = 
  match d with
    Dtag_color(d,c) -> Dtag_color(color_nesting d,c)
  | Dlist(dl) -> 
      begin
	match wrapper_adjacent_color (List.map color_nesting dl) with
	  [e] -> e
	| l -> Dlist(l) 
      end
  | Dtag_B(d) -> 
      begin
	let d' = color_nesting d in 
	match  d' with
	  Dtag_color(d',c') -> Dtag_color( Dtag_B(d'),c')
	|	_ -> Dtag_B(d')
      end
  | Dtag_EM(d) -> 
      begin
	let d' = color_nesting d in 
	match  d' with
	  Dtag_color(d',c') -> Dtag_color(Dtag_EM(d'),c')
	| _ -> Dtag_EM(d')
      end
  | Dtag_I(d) -> 
      begin
	let d' = color_nesting d in 
	match  d' with
	  Dtag_color(d',c') -> Dtag_color(Dtag_I(d'),c')
	|	_ -> Dtag_I(d')
      end
  | Dtag_PL(d) -> 
      begin
	let d' = color_nesting d in 
	match  d' with
	  Dtag_color(d',c') -> Dtag_color(Dtag_PL(d') ,c')
	| _ -> Dtag_PL(d')
      end
  | Dtag_S(d) -> 
      begin
	let d' = color_nesting d in 
	match  d' with
	  Dtag_color(d',c') -> Dtag_color(Dtag_S(d'),c')
	| _ -> Dtag_S(d')
      end
  | Dtag_TT(d) -> 
      begin
	let d' = color_nesting d in 
	match d' with
	  Dtag_color(d',c') -> Dtag_color(Dtag_TT(d'),c')
	| _ -> Dtag_TT(d')
      end
  | Dtag_U(d) -> 
      begin
	let d' = color_nesting d in 
	match d' with
	  Dtag_color(d',c') -> Dtag_color(Dtag_U(d'),c')
	| _ -> Dtag_U(d')
      end
  | Dtag_size(d,s) -> 
      begin
	let d' = color_nesting d in 
	match d' with
	  Dtag_color(d',c') -> Dtag_color(Dtag_size(d',s),c')
	| _ -> Dtag_size(d',s)
      end
  | _ -> d

and merge_doc d1 d2 =
  match d1,d2 with
    Dtag_color(d1',c1) , Dtag_color(d2',c2) when c1=c2 -> 
      let e = 
	match d1',d2' with
	  Dlist(l1),Dlist(l2) -> Dlist(append l1 l2)
	| Dlist(l) , _ -> Dlist(append l [d2'])
	| _ , Dlist(l) -> Dlist(d1'::l)
	| _ , _ -> Dlist([d1';d2'])
      in
      Dtag_color(e,c1)
  | _ -> raise Colornestingmerge

and wrapper_adjacent_color tdl = 
  match tdl with
    [] -> []
  | x::l -> 
      match x with
	Dtag_color(d,c) -> adjacent_color x l
      |	_ -> x::(wrapper_adjacent_color l)

and merge_deep de1 de2 c =
  match de1 with
    Dtag_color(d,c') -> 
      if c=c' then  merge_doc de1 de2
      else
	begin
	  match d with
	    Dlist(dl) -> 
		let rec trav  = function
		    [] -> [de2]
		  | [Dtag_color(d3,c3) as de3] -> [merge_deep de3 de2 c]
		  | x::l -> x::(trav l)
		in Dtag_color(Dlist(trav dl),c')
	  | _ -> (*color_nesting*)(Dtag_color(Dlist([d;de2]),c'))
	end
  | _ ->  raise Colornestingmergedeep

and adjacent_color x dl = 
  match dl with
    [] -> [x]
  | t::l -> 
      match t with
	Dtag_color(d,c') -> adjacent_color (merge_deep x t c')  l
      |	_ -> x::t::(wrapper_adjacent_color l)


(* -------------- avec flat_lists-----------------*)

let rec flatlists_doc x =
  match x with
    Dtag_color(d,c) -> Dtag_color(flatlists_doc d , c )
  | Dtag_B(d) -> Dtag_B(flatlists_doc d)
  | Dtag_EM(d) -> Dtag_EM(flatlists_doc d)
  | Dtag_I(d) -> Dtag_I(flatlists_doc d)
  | Dtag_PL(d) -> Dtag_PL(flatlists_doc d)
  | Dtag_S(d) -> Dtag_S(flatlists_doc d)
  | Dtag_TT(d) -> Dtag_TT(flatlists_doc d)
  | Dtag_U(d) -> Dtag_U(flatlists_doc d)
  | Dtag_size(d,s) -> Dtag_size(flatlists_doc d , s)
  | Dlist(dl) -> 
      let f = List.map flatlists_doc dl in
      let cat x y = 
        begin
          match x with
            Dlist(tdl)-> append tdl y
          | _ -> x::y 
        end in
      Dlist(List.fold_right cat f [])
  | _ -> x

let rec color_nesting_flat d = 
  match d with
    Dtag_color(d,c) -> Dtag_color(color_nesting_flat d,c)
  | Dlist(dl) -> 
      begin
	match wrapper_adjacent_color_flat (List.map color_nesting_flat dl) with
	  [e] -> e
	| l -> Dlist(l) 
      end
  | Dtag_B(d) -> 
      begin
	let d' = color_nesting_flat d in 
	match  d' with
	  Dtag_color(d',c') -> Dtag_color( Dtag_B(d'),c')
	|	_ -> Dtag_B(d')
      end
  | Dtag_EM(d) -> 
      begin
	let d' = color_nesting_flat d in 
	match  d' with
	  Dtag_color(d',c') -> Dtag_color(Dtag_EM(d'),c')
	| _ -> Dtag_EM(d')
      end
  | Dtag_I(d) -> 
      begin
	let d' = color_nesting_flat d in 
	match  d' with
	  Dtag_color(d',c') -> Dtag_color(Dtag_I(d'),c')
	|	_ -> Dtag_I(d')
      end
  | Dtag_PL(d) -> 
      begin
	let d' = color_nesting_flat d in 
	match  d' with
	  Dtag_color(d',c') -> Dtag_color(Dtag_PL(d') ,c')
	| _ -> Dtag_PL(d')
      end
  | Dtag_S(d) -> 
      begin
	let d' = color_nesting_flat d in 
	match  d' with
	  Dtag_color(d',c') -> Dtag_color(Dtag_S(d'),c')
	| _ -> Dtag_S(d')
      end
  | Dtag_TT(d) -> 
      begin
	let d' = color_nesting_flat d in 
	match d' with
	  Dtag_color(d',c') -> Dtag_color(Dtag_TT(d'),c')
	| _ -> Dtag_TT(d')
      end
  | Dtag_U(d) -> 
      begin
	let d' = color_nesting_flat d in 
	match d' with
	  Dtag_color(d',c') -> Dtag_color(Dtag_U(d'),c')
	| _ -> Dtag_U(d')
      end
  | Dtag_size(d,s) -> 
      begin
	let d' = color_nesting_flat d in 
	match d' with
	  Dtag_color(d',c') -> Dtag_color(Dtag_size(d',s),c')
	| _ -> Dtag_size(d',s)
      end
  | _ -> d

and merge_doc_flat d1 d2 =
  match d1,d2 with
    Dtag_color(d1',c1) , Dtag_color(d2',c2) when c1=c2 -> 
      let dl = flatlists_doc (Dlist([d1';d2'])) in
      Dtag_color(dl,c1)
  | _ -> raise Colornestingmerge

and wrapper_adjacent_color_flat tdl = 
  match tdl with
    [] -> []
  | x::l -> 
      match x with
	Dtag_color(d,c) -> adjacent_color_flat x l
      |	_ -> x::(wrapper_adjacent_color_flat l)

and merge_deep_flat de1 de2 c =
  match de1 with
    Dtag_color(d,c') -> 
      if c=c' then  merge_doc_flat de1 de2
      else
	begin
	  match d with
	    Dlist(dl) -> 
		let rec trav  = function
		    [] -> [de2]
		  | [Dtag_color(d3,c3) as de3] -> [merge_deep_flat de3 de2 c]
		  | x::l -> x::(trav l)
		in Dtag_color(Dlist(trav dl),c')
	  | _ -> (*color_nesting_flat*)(Dtag_color(Dlist([d;de2]),c'))
	end
  | _ ->  raise Colornestingmergedeep

and adjacent_color_flat x dl = 
  match dl with
    [] -> [x]
  | t::l -> 
      match t with
	Dtag_color(d,c') -> adjacent_color_flat (merge_deep_flat x t c')  l
      |	_ -> x::t::(wrapper_adjacent_color_flat l)



let rec tdoc_to_doc td = 
  match td.expr with
    Ttag_B(td) -> Dtag_B(tdoc_to_doc td)
  | Ttag_EM(td) -> Dtag_EM(tdoc_to_doc td)
  | Ttag_I(td) -> Dtag_I(tdoc_to_doc td)
  | Ttag_PL(td) -> Dtag_PL(tdoc_to_doc td)
  | Ttag_S(td) -> Dtag_S(tdoc_to_doc td)
  | Ttag_TT(td) -> Dtag_TT(tdoc_to_doc td)
  | Ttag_U(td) -> Dtag_U(tdoc_to_doc td)
  | Ttag_color(td,c) -> Dtag_color(tdoc_to_doc td , c)
  | Ttag_size(td,s) -> Dtag_size(tdoc_to_doc td , s)
  | Tlist(tdl) -> Dlist(List.map tdoc_to_doc tdl)
  | Tstring(s) -> Dstring(s)


let nesting_doc d = B8_sizenesting.size_nesting (color_nesting d)
let nesting td =  B8_typedoc.typedoc (nesting_doc (tdoc_to_doc td))
let _ = B8_types.register "nesting" nesting 40


let nesting_doc_flat d = B8_sizenesting.size_nesting_flat (color_nesting_flat d)
let nesting_flat td = B8_typedoc.typedoc (nesting_doc_flat (tdoc_to_doc td))
let _ = B8_types.register "nesting_flat" nesting_flat 40



