(* size nesting *)

open B8_types

exception Sizenestingmerge
exception Sizenestingmergedeep


let rec append_aux acc l = 
  match l with
    [] -> acc
  | x::l' -> append_aux (x::acc) l'

let  append l1 l2 = 
  append_aux l2 (List.rev l1)

let rec size_nesting d = 
  match d with
    Dtag_size(d,c) -> Dtag_size(size_nesting d,c) 
  | Dlist(dl) ->
      begin
	match  wrapper_adjacent_size (List.map size_nesting dl) with
	  [e] -> e
	| l -> Dlist(l) 
      end

  | Dtag_B(d) -> 
      begin
	let d' = size_nesting d in 
	match d' with
	  Dtag_size(d',c') -> Dtag_size( Dtag_B(d') ,c')
	|	_ -> Dtag_B(d')
      end
  | Dtag_EM(d) -> 
      begin
	let d' = size_nesting d in 
	match d' with
	  Dtag_size(d',c') -> Dtag_size( Dtag_EM(d') ,c')
	|	_ -> Dtag_EM(d')
      end
  | Dtag_I(d) -> 
      begin
	let d' = size_nesting d in 
	match d' with
	  Dtag_size(d',c') -> Dtag_size(Dtag_I(d') ,c')
	|	_ -> Dtag_I(d')
      end
  | Dtag_PL(d) -> 
      begin
	let d' = size_nesting d in 
	match d' with
	  Dtag_size(d',c') -> Dtag_size(Dtag_PL(d') ,c')
	|	_ -> Dtag_PL(d')
      end
  | Dtag_S(d) -> 
     begin
       let d' = size_nesting d in 
       match d' with
	 Dtag_size(d',c') -> Dtag_size(Dtag_S(d') ,c')
       |	_ -> Dtag_S(d')
     end
  | Dtag_TT(d) -> 
      begin
	let d' = size_nesting d in 
	match d' with
	  Dtag_size(d',c') -> Dtag_size(Dtag_TT(d') ,c')
	|	_ -> Dtag_TT(d')
      end
  | Dtag_U(d) -> 
      begin
	let d' = size_nesting d in 
	match d' with
	  Dtag_size(d',c') -> 
	    Dtag_size(Dtag_U(d') ,c')
	|	_ -> Dtag_U(d')
      end
  | Dtag_color(d,s) -> 
      begin
	let d' = size_nesting d in 
	match d' with
	  Dtag_size(d',c') -> Dtag_size(Dtag_color(d',s),c')
	|	_ -> Dtag_color(d',s)
      end
  | _ -> d

and  merge_doc d1 d2 =
  match d1,d2 with
    Dtag_size(d1',c1) , Dtag_size(d2',c2) when c1=c2 -> 
      let e = 
	match d1',d2' with
	  Dlist(l1),Dlist(l2) -> Dlist(append l1 l2)
	| Dlist(l) , _ -> Dlist(append l [d2'])
	| _ , Dlist(l) -> Dlist(d1'::l)
	| _ , _ -> Dlist([d1';d2'])
      in
      Dtag_size(e,c1)
  | _ -> raise Sizenestingmerge

and wrapper_adjacent_size dl = 
  match dl with
    [] -> []
  | x::l -> 
      match x with
	Dtag_size(d,c) -> adjacent_size x l
      |	_ -> x::(wrapper_adjacent_size l)

and merge_deep de1 de2 c =
  match de1 with
    Dtag_size(d,c') -> 
      if c=c' then  merge_doc de1 de2
      else
	begin
	  match d with
	    Dlist(dl) -> 
	      begin
		let rec trav  = function
		    [] -> [de2]
		  |	[Dtag_size(d3,c3) as de3] -> [(merge_deep de3 de2 c )]
		  |	x::l -> x::(trav l)
		in Dtag_size(Dlist(trav dl), c')
	      end
	  | _ -> Dtag_size(Dlist([d;de2]),c')
	end
  | _ ->  raise Sizenestingmergedeep


and adjacent_size x dl = 
  match dl with
    [] -> [x]
  | t::l -> 
      match t with
	Dtag_size(d,c') -> 
	  adjacent_size (merge_deep x t c') l
      |	_ -> x::t::(wrapper_adjacent_size l)

(* =================== avec flatlists ======================*)


let rec flatlists_doc x =
  match x with
    Dtag_color(d,c) -> Dtag_color(flatlists_doc d , c )
  | Dtag_B(d) -> Dtag_B(flatlists_doc d)
  | Dtag_EM(d) -> Dtag_EM(flatlists_doc d)
  | Dtag_I(d) -> Dtag_I(flatlists_doc d)
  | Dtag_PL(d) -> Dtag_PL(flatlists_doc d)
  | Dtag_S(d) -> Dtag_S(flatlists_doc d)
  | Dtag_TT(d) -> Dtag_TT(flatlists_doc d)
  | Dtag_U(d) -> Dtag_U(flatlists_doc d)
  | Dtag_size(d,s) -> Dtag_size(flatlists_doc d , s)
  | Dlist(dl) -> 
      let f = List.map flatlists_doc dl in
      let cat x y = 
        begin
          match x with
            Dlist(tdl)-> append tdl y
          | _ -> x::y 
        end in
      Dlist(List.fold_right cat f [])
  | _ -> x

let rec size_nesting_flat d = 
  match d with
    Dtag_size(d,c) -> Dtag_size(size_nesting_flat d,c) 
  | Dlist(dl) ->
      begin
	match  wrapper_adjacent_size_flat (List.map size_nesting_flat dl) with
	  [e] -> e
	| l -> Dlist(l) 
      end

  | Dtag_B(d) -> 
      begin
	let d' = size_nesting_flat d in 
	match d' with
	  Dtag_size(d',c') -> Dtag_size( Dtag_B(d') ,c')
	|	_ -> Dtag_B(d')
      end
  | Dtag_EM(d) -> 
      begin
	let d' = size_nesting_flat d in 
	match d' with
	  Dtag_size(d',c') -> Dtag_size( Dtag_EM(d') ,c')
	|	_ -> Dtag_EM(d')
      end
  | Dtag_I(d) -> 
      begin
	let d' = size_nesting_flat d in 
	match d' with
	  Dtag_size(d',c') -> Dtag_size(Dtag_I(d') ,c')
	|	_ -> Dtag_I(d')
      end
  | Dtag_PL(d) -> 
      begin
	let d' = size_nesting_flat d in 
	match d' with
	  Dtag_size(d',c') -> Dtag_size(Dtag_PL(d') ,c')
	|	_ -> Dtag_PL(d')
      end
  | Dtag_S(d) -> 
     begin
       let d' = size_nesting_flat d in 
       match d' with
	 Dtag_size(d',c') -> Dtag_size(Dtag_S(d') ,c')
       |	_ -> Dtag_S(d')
     end
  | Dtag_TT(d) -> 
      begin
	let d' = size_nesting_flat d in 
	match d' with
	  Dtag_size(d',c') -> Dtag_size(Dtag_TT(d') ,c')
	|	_ -> Dtag_TT(d')
      end
  | Dtag_U(d) -> 
      begin
	let d' = size_nesting_flat d in 
	match d' with
	  Dtag_size(d',c') -> 
	    Dtag_size(Dtag_U(d') ,c')
	|	_ -> Dtag_U(d')
      end
  | Dtag_color(d,s) -> 
      begin
	let d' = size_nesting_flat d in 
	match d' with
	  Dtag_size(d',c') -> Dtag_size(Dtag_color(d',s),c')
	|	_ -> Dtag_color(d',s)
      end
  | _ -> d

and  merge_doc_flat d1 d2 =
  match d1,d2 with
    Dtag_size(d1',c1) , Dtag_size(d2',c2) when c1=c2 -> 
      let dl = flatlists_doc (Dlist([d1';d2'])) in
      Dtag_size(dl,c1)
  | _ -> raise Sizenestingmerge

and wrapper_adjacent_size_flat dl = 
  match dl with
    [] -> []
  | x::l -> 
      match x with
	Dtag_size(d,c) -> adjacent_size_flat x l
      |	_ -> x::(wrapper_adjacent_size_flat l)

and merge_deep_flat de1 de2 c =
  match de1 with
    Dtag_size(d,c') -> 
      if c=c' then  merge_doc_flat de1 de2
      else
	begin
	  match d with
	    Dlist(dl) -> 
	      begin
		let rec trav  = function
		    [] -> [de2]
		  |	[Dtag_size(d3,c3) as de3] -> [(merge_deep_flat de3 de2 c )]
		  |	x::l -> x::(trav l)
		in Dtag_size(Dlist(trav dl), c')
	      end
	  | _ -> Dtag_size(Dlist([d;de2]),c')
	end
  | _ ->  raise Sizenestingmergedeep

and adjacent_size_flat x dl = 
  match dl with
    [] -> [x]
  | t::l -> 
      match t with
	Dtag_size(d,c') -> 
	  adjacent_size_flat (merge_deep_flat x t c') l
      |	_ -> x::t::(wrapper_adjacent_size_flat l)




let rec tdoc_to_doc td = 
  match td.expr with
    Ttag_B(td) -> Dtag_B(tdoc_to_doc td)
  | Ttag_EM(td) -> Dtag_EM(tdoc_to_doc td)
  | Ttag_I(td) -> Dtag_I(tdoc_to_doc td)
  | Ttag_PL(td) -> Dtag_PL(tdoc_to_doc td)
  | Ttag_S(td) -> Dtag_S(tdoc_to_doc td)
  | Ttag_TT(td) -> Dtag_TT(tdoc_to_doc td)
  | Ttag_U(td) -> Dtag_U(tdoc_to_doc td)
  | Ttag_color(td,c) -> Dtag_color(tdoc_to_doc td , c)
  | Ttag_size(td,s) -> Dtag_size(tdoc_to_doc td , s)
  | Tlist(tdl) -> Dlist(List.map tdoc_to_doc tdl)
  | Tstring(s) -> Dstring(s)





