(* tom *)

open B8_types

let rec is_empty doc = 
  match doc.expr with
  | (Ttag_B doc' | Ttag_EM doc' 
  | Ttag_I doc' | Ttag_PL doc' | Ttag_S doc' | Ttag_TT doc' | Ttag_U doc' 
  | Ttag_color(doc', _) | Ttag_size (doc', _) ) ->
      is_empty doc'
  | Tlist docs -> List.for_all is_empty docs 
  | Tstring "" -> true
  | _ -> false

let rec remove_garbage doc =
  if is_empty doc then 
    doc.expr <- Tstring ""
  else
    match doc.expr with
    | (Ttag_B doc' | Ttag_EM doc' 
    | Ttag_I doc' | Ttag_PL doc' | Ttag_S doc' | Ttag_TT doc' | Ttag_U doc' 
    | Ttag_color(doc', _) | Ttag_size (doc', _) ) ->
	remove_garbage doc'
    | Tlist docs -> 
	let docs' = 
	  List.filter (fun x -> not (is_empty x)) docs 
	in
	List.iter (fun doc -> remove_garbage doc) docs';
	doc.expr <- Tlist docs'
    | _ -> ()

let garbage doc = 
  remove_garbage doc; doc

let () = register "garbage" garbage (-1)
